/*
 *  franctions.h
 */

#include <stdio.h>

typedef struct frac {
  int num;
  int den;
} frac;

// plus grand commun diviseur
unsigned int pgcd(int a, int b) {
  int app;
  while (b != 0) {
    app = b;
    b = a%b;
    a = app;
  }
  if (a < 0) return -a;
  return a;
}

// plus petit commun multiple
unsigned int ppcm(int a, int b) {
  return a*b/pgcd(a,b);
}

void liref(frac *f) {
  printf("tapez numerateur et denominateur -- ");
  scanf("%d",&(f->num));
  scanf("%d",&(f->den));
  while(f->den == 0) {
    printf("denominateur nul ! tapez a noveau le seul denominateur -- ");
    scanf("%d",&(f->den));
  }
}

void affichef(frac f) {
  if(f.den == 1) {
    printf("%d",f.num);
  } else {
    printf("%d/%d",f.num,f.den);
  }
}

void simplf(frac *f) {
  const int p = pgcd(f->num,f->den);
  if (p == 1) return;
  if (f->den > 0) {
    f->num /= p;
    f->den /= p;
  } else {
    f->num /= -p;
    f->den /= -p;
  }
}

frac sommef(frac a, frac b) {
  a.num = a.num*b.den + a.den*b.num;
  a.den *= b.den;
  simplf(&a);
  return a;
}

frac difff(frac a, frac b) {
  a.num = a.num*b.den - a.den*b.num;
  a.den *= b.den;
  simplf(&a);
  return a;
}

frac prodf(frac a, frac b) {
  a.num *= b.num;
  a.den *= b.den;
  simplf(&a);
  return a;
}

frac invf(frac a) {
  int app = a.num;
  a.num = a.den;
  a.den = a.num;
  return a;
}
  
frac divf(frac a, frac b) {
  return prodf(a,invf(b));
}

// puissance de fractions avec l'algorithme des carrés successifs
// calcule aussi avec un exponant negatif (mais ne fait pas
// de contrôle sur b != 0 dans ce cas)
frac puissf(frac b, int e) {
  frac res;
  res.num = 1; // initialisation à 1/1
  res.den = 1;
  if (e < 0) {
    b = invf(b);
    e = -e;
  }
  while (e != 0) {
    if(e%2 != 0) {
      res = prodf(res,b);
    }
    e /= 2;
    b = prodf(b,b);
  }
  return res;
}

unsigned int egalzerof(frac a) {
  return a.num == 0;
}

unsigned int egalunf(frac a) {
  return a.num == a.den;
}

unsigned int egalmoinsunf(frac a) {
  return a.num == -a.den;
}

unsigned int egalf(frac a,frac b) {
  return a.num*b.den == b.num*a.den;
}

// a plus grand que b
unsigned int pgf(frac a, frac b) {
  simplf(&a); // on s'assure que a.den et b.den sont positifs
  simplf(&b);
  return a.num*b.den > b.num*a.den;
}

// a plus grand de 0
unsigned int pgzerof(frac a) {
  return a.num*a.den > 0;
}

// a plus grand ou égal à b
unsigned int pgef(frac a, frac b) {
  simplf(&a);
  simplf(&b);
  return a.num*b.den >= b.num*a.den;
}

