/*
 *  liste.h
 */

#include <stdlib.h>

typedef int data;
void affichedata(data d) {
  printf("%d",d);
}

typedef struct node {
  data x;
  struct node *next;
} node;

node* prepend(node *head,data i) {
  node *n;
  n = malloc(sizeof(node));
  n->x = i;
  n->next = head;
  return n;
}

node* append(node *head,data i) {
  if (head == NULL) {
    head = malloc(sizeof(node));
    head->x = i;
    head->next = NULL;
    return head;
  }
  node *n = head;
  while(n->next != NULL) n = n->next;
  n->next = malloc(sizeof(node));
  n = n->next;
  n->x = i;
  n->next = NULL;
  return head;
}

void afficheliste(node *head) {
  if (head == NULL) {
    printf("< >");
    return;
  }
  printf ("< ");
  affichedata(head->x);
  head = head->next;
  while (head != NULL) {
    printf(", ");
    affichedata(head->x);
    head = head->next;
  }
  printf(" >");
}

node* rmfirst(node *head) {
  if (head == NULL) return NULL;
  node *n = head->next;
  free(head);
  return n;
}

node* rmlast(node *head) {
  if (head == NULL) return NULL;
  if (head->next == NULL) {
    free(head);
    return NULL;
  }
  node *n = head;
  while (n->next->next != NULL) n = n->next;
  free(n->next);
  n->next = NULL;
  return head;
}

node *avantlast(node *head) {
  if (head == NULL || head->next == NULL) return NULL;
  while (head->next->next != NULL) head = head->next;
  return head;
}
  
